import { Body, Get, JsonController, Res } from 'routing-controllers';
import { OpenAPI } from 'routing-controllers-openapi';
import { PdfCreator } from '../PdfCreator';

@JsonController()
export class PdfController {
    private pdf: PdfCreator;
    constructor() {
        this.pdf = new PdfCreator();
    }

    @Get('/contracts')
    @OpenAPI({ description: "Generate Sponsoring contract pdfs from runner objects." })
    async generateContracts(@Body({ validate: true }) runner: any, @Res() res: any) {
        const contracts = await this.pdf.generateSponsoringContract(runner);
        res.setHeader('content-type', 'application/pdf');
        return await contracts;
    }
}