import {
    IsInt,
    IsObject,
    IsString
} from "class-validator";
import { RunnerGroup } from './RunnerGroup';

/**
 * Defines the runner class (from which the runner sponsoring contracts get generated).
*/
export class Runner {
    /**
     * The runner's id.
     */
    @IsInt()
    id: number;

    /**
     * The runner's first name.
     */
    @IsString()
    firstname: string;

    /**
     * The runner's middle name.
     */
    @IsString()
    middlename?: string;

    /**
     * The runner's last name.
     */
    @IsString()
    lastname: string;

    /**
     * The runner's group.
     */
    @IsObject()
    group: RunnerGroup;

    /**
     * The total distance ran by the runner.
     */
    @IsInt()
    distance: number;
}
